diff --git a/swayidle/main.c b/swayidle/main.c
index 6023528040..15f319c3e1 100644
--- a/swayidle/main.c
+++ b/swayidle/main.c
@@ -340,6 +340,9 @@ void sig_handler(int signal) {
 }
 
 static int display_event(int fd, uint32_t mask, void *data) {
+	if (mask & WL_EVENT_HANGUP) {
+		sway_terminate(0);
+	}
 	wl_display_dispatch(state.display);
 	return 0;
 }
